routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware('cekakun')->group(function () {
    Route::get('/', "Dashboard\DashboardController@index")->name('dashboard');
    Route::get('test_word/{id}', "Dashboard\DashboardController@testWord");
    Route::resource("jabatan","DataMaster\JabatanController");
    Route::resource("tempat_tugas","DataMaster\TipePegawaiController");
    Route::resource("tempat_presensi","Presensi\TempatPresensiController");
    Route::resource("pegawai","Pengguna\PegawaiController");
    Route::resource("akun","Pengguna\AkunController");
    Route::get("all_pegawai","Pengguna\PegawaiController@all_pegawai");
    Route::resource('rule_presensi','Presensi\RulePresensiController');
    Route::resource('waktu_presensi','Presensi\WaktuPresensiController');
    Route::resource('rule_hari_libur','Presensi\RuleHariLiburController');
    Route::get("logout","Auth\LoginController@logout")->name('logout');
    Route::resource('belum_presensi', 'Presensi\BelumPresensiController');
    Route::resource('log_presensi', 'Presensi\PresensiController');
    Route::get('log_presensi/group/{tipe}','Presensi\PresensiController@showPerTempatTugas');
    Route::post('print_data', 'Presensi\PresensiController@rekapData');
    Route::get('detail_presensi/{pegawai}','Presensi\PresensiController@detailPresensi');
    // Cetak Data
    Route::get('printData','Presensi\PresensiController@printData');
    Route::post('print_data_kolektif', 'Presensi\PresensiController@rekapDataKolektif');
    Route::get('cetak_pdf_kolektif/{pegawai}','Presensi\PresensiController@printDataCollective');
    Route::post('cetak_pdf_all_kolektif','Presensi\PresensiController@cetakAllPegawai');
    Route::get('print_pdf_all_kolektif/{tipe}','Presensi\PresensiController@printDataAll');
    Route::get('presensi_excel/{id}','Presensi\PresensiController@exportExcel');
    //Route::get('log_presensi_pegawai/{id}','Presensi\PresensiController@show');
    Route::post('ketidakhadiran/add', 'Presensi\KetidakhadiranController@addIzin');
    Route::resource('ketidakhadiran', 'Presensi\KetidakhadiranController');
    Route::get('pengajuan_izin_cuti/{idpegawai}/{presensiid}','Presensi\KetidakhadiranController@cetakPengajuanCutiIzin');
    Route::resource('periode','Presensi\PeriodeController');
    Route::post('surat/act','Penugasan\TugasController@update');

    // Penugasan
    Route::get('penugasan/rekap', 'Penugasan\TugasController@rekap');
    Route::get('penugasan/cetak_pdf', 'Penugasan\TugasController@cetakPdf');
    Route::get('penugasan/export_excel', 'Penugasan\TugasController@export_excel');
    Route::resource('penugasan','Penugasan\TugasController');
    Route::get('penugasan/detail/{id}', 'Penugasan\TugasController@detail');
    Route::put('penugasan/detail/batal', 'Penugasan\TugasController@batal');
    Route::put('penugasan/detail/kirim', 'Penugasan\TugasController@kirim');
    Route::put('penugasan/detail/selesai', 'Penugasan\TugasController@selesai');
    Route::resource('surat','Penugasan\SuratController');
    Route::resource('aktivitas','Penugasan\AktivitasController');
    Route::get('aktifitas/rekap', 'Penugasan\AktivitasController@rekap');
    Route::get('aktifitas/cetak_pdf', 'Penugasan\AktivitasController@cetakPdf');
    Route::get('aktifitas/export_excel', 'Penugasan\AktivitasController@export_excel');
    Route::get("cek/{tgl1}/{tgl2}/{pegawai}", function($tgl1, $tgl2, $pegawai){
        $status = "accepted";
        $cek = \App\Presensi::where('presensi.pegawai_id',$pegawai)
            ->where('presensi.tipe_izin','<>',null)
            ->where('presensi.status_izin',$status)
            ->where('presensi.tipe_izin', 'dinas_luar')
            ->whereBetween('presensi.tgl_presensi',array($tgl1, $tgl2))
            ->count();
        echo $cek;
    });
});

Route::middleware('sudahlogin')->group(function () {
    Route::get("login","Auth\LoginController@showLoginForm")->name('login');
    Route::post("post_login","Auth\LoginController@post_login")->name('post_login');
});

app/Http/Controllers/Pengguna/AkunController.php
<?php

namespace App\Http\Controllers\Pengguna;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\User;

class AkunController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $akun = User::where('tipeakun','adm')->get();
        return view('pengguna.akun.index',compact('akun'));
    }


    public function validation($request)
    {
        $validate_data = $this->validate(
            $request,
            [
                'username' => 'required',
                'password' => 'required',
                'password_hint' => 'required',
            ],
            [
                'username.required' => 'Username akun harus diisi',
                'password.required' => 'Password akun harus diisi',
                'password_hint.required' => 'Password petunjuk harus diisi',
            ]
        );
        return $validate_data;
    }

    public function validation2($request)
    {
        $validate_data = $this->validate(
            $request,
            [
                'username' => 'required',
                'password_hint' => 'required',
            ],
            [
                'username.required' => 'Username akun harus diisi',
                'password_hint.required' => 'Password petunjuk harus diisi',
            ]
        );
        return $validate_data;
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $page = "create";
        $title = "Tambah Akun";
        return view("pengguna.akun.create_edit", compact("page","title"));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validation($request);
        $userid = generateRandom(10);
        $user = new User();
        $user->userid = $userid;
        $user->username = $request->username;
        $user->tipeakun = "adm";
        $user->password = bcrypt($request->password);
        $user->password_hint = $request->password_hint;
        $user->save();
        return redirect('akun')->with('success','Berhasil Menambah Data Akun Admin');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $page = "edit";
        $title = "Edit Data Akun";
        $akun = User::find($id);
        return view("pengguna.akun.create_edit", compact("page","title","akun"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validation2($request);
        $user = User::find($id);
        $user->username = $request->username;
        if($request->password != "")
            $user->password = bcrypt($request->password);
        $user->password_hint = $request->password_hint;
        $user->save();
        return redirect('akun')->with('success','Berhasil Mengubah Data Akun Admin');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $akun = User::find($id);
        $akun->delete();
        return redirect('akun')->with('success','Berhasil Menghapus Data Akun Admin');
    }
}

app/Http/Controllers/Pengguna/PegawaiController.php
<?php

namespace App\Http\Controllers\Pengguna;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Pegawai;
use App\User;
use App\Jabatan;
use App\TipePegawai;
use App\TempatPresensi;

class PegawaiController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $pegawai = Pegawai::join("akun","pegawai.userid","=","akun.userid")
            ->join("jabatan","pegawai.id_jabatan","=","jabatan.id")
            ->join("tipe_pegawai","pegawai.id_tipepeg","=","tipe_pegawai.id")
            ->join("tempat_presensi","pegawai.id_tempat","=","tempat_presensi.id")
            ->select("pegawai.*","jabatan.*","akun.*","tipe_pegawai.*","tempat_presensi.*",
                "pegawai.alamat as alamat_peg")->get();
        return view("pengguna.pegawai.index",compact("pegawai"));
    }

    public function validation($request)
    {
        $validate_data = $this->validate(
            $request,
            [
                'nip' => 'required',
                'username' => 'required',
                'password' => 'required',
                'nama' => 'required',
                'alamat' => 'required',
                'pangkat' => 'required',
                'golongan' => 'required',
                'foto' => 'required',
                'id_jabatan' => 'required',
                'id_tipepeg' => 'required',
                'id_tempat' => 'required',
            ],
            [
                'nip.required' => 'NIP pegawai harus diisi',
                'username.required' => 'Username pegawai harus diisi',
                'password.required' => 'Password pegawai harus diisi',
                'nama.required' => 'Nama pegawai harus diisi',
                'alamat.required' => 'Alamat pegawai harus diisi',
                'foto.required' => 'Foto pegawai harus ada',
                'id_jabatan.required' => 'Jabatan pegawai harus diisi',
                'pangkat.required' => 'Pangkat pegawai harus diisi',
                'golongan.required' => 'Golongan pegawai harus diisi',
                'id_tipepeg.required' => 'Tipe pegawai harus diisi',
                'id_tempat.required' => 'Tempat pegawai presensi harus diisi',
            ]
        );
        return $validate_data;
    }

    public function validation2($request)
    {
        $validate_data = $this->validate(
            $request,
            [
                'nip' => 'required',
                'username' => 'required',
                'nama' => 'required',
                'alamat' => 'required',
                'id_jabatan' => 'required',
                'pangkat' => 'required',
                'golongan' => 'required',
                'id_tipepeg' => 'required',
                'id_tempat' => 'required',
            ],
            [
                'nip.required' => 'NIP pegawai harus diisi',
                'username.required' => 'Username pegawai harus diisi',
                'nama.required' => 'Nama pegawai harus diisi',
                'alamat.required' => 'Alamat pegawai harus diisi',
                'id_jabatan.required' => 'Jabatan pegawai harus diisi',
                'pangkat.required' => 'Pangkat pegawai harus diisi',
                'golongan.required' => 'Golongan pegawai harus diisi',
                'id_tipepeg.required' => 'Tipe pegawai harus diisi',
                'id_tempat.required' => 'Tempat pegawai presensi harus diisi',
            ]
        );
        return $validate_data;
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $page = "create";
        $title = "Tambah Pegawai";
        $jabatan = jabatan::all();
        $tipe_pegawai = TipePegawai::all();
        $tempat_presensi = TempatPresensi::all();
        return view("pengguna.pegawai.create_edit",
            compact("page","title","jabatan","tipe_pegawai","tempat_presensi"));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validation($request);
        $userid = generateRandom(10);
        $user = User::create([
            'userid' => $userid,
            'username' => $request->username,
            'password' => bcrypt($request->password),
            'tipeakun' => "peg",
            "password_hint" => $request->password_hint
        ]);

        $resorce = $request->file('foto');
        $fileName = time().$resorce->getClientOriginalName();
        $resorce->move(\base_path() ."/public/files/images_profil", $fileName);

        $pegawai = Pegawai::create($request->except(['username','password','foto'])+[
            'userid' => $userid,
            'foto' => $fileName
        ]);
        return redirect('pegawai')->with('success','Berhasil Menambah Data Pegawai');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $page = "edit";
        $title = "Edit Data Pegawai";
        $pegawai = Pegawai::join("akun","pegawai.userid","=","akun.userid")
            ->join("jabatan","pegawai.id_jabatan","=","jabatan.id")
            ->join("tipe_pegawai","pegawai.id_tipepeg","=","tipe_pegawai.id")
            ->join("tempat_presensi","pegawai.id_tempat","=","tempat_presensi.id")
            ->where("pegawai.id_pegawai",$id)->first();
        $jabatan = Jabatan::all();
        $tipe_pegawai = TipePegawai::all();
        $tempat_presensi = TempatPresensi::all();
        return view("pengguna.pegawai.create_edit",
            compact("page","title","jabatan","tipe_pegawai","tempat_presensi","pegawai"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validation2($request);
        $pegawai = Pegawai::find($id);
        $akun = User::find($pegawai->userid);
        $akun->username = $request->username;
        if($request->password != ""){
            $akun->password = bcrypt($request->password);
        }
        $akun->password_hint = $request->password_hint;
        $akun->save();

        if($request->file('foto') != ""){
            \File::delete(public_path('files/images_profil/'.$pegawai->foto));
            $resorce = $request->file('foto');
            $fileName   = time().$resorce->getClientOriginalName();
            $resorce->move(\base_path() ."/public/files/images_profil", $fileName);
            $pegawai->foto = $fileName;
        }
        $pegawai->nip = $request->nip;
        $pegawai->nama = $request->nama;
        $pegawai->alamat = $request->alamat;
       
        $pegawai->id_jabatan = $request->id_jabatan;
        $pegawai->pangkat = $request->pangkat;
        $pegawai->golongan = $request->golongan;
        $pegawai->id_tipepeg = $request->id_tipepeg;
        $pegawai->id_tempat = $request->id_tempat;
        $pegawai->save();
        return redirect('pegawai')->with('success','Berhasil Mengubah Pegawai');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        \DB::statement('SET FOREIGN_KEY_CHECKS=0;');
        $pegawai = Pegawai::find($id);
        $userid = $pegawai->userid;
        \File::delete(public_path('files/images_profil/'.$pegawai->foto));
        $pegawai->delete();
        $user = User::where("userid",$userid)->delete();
        return redirect('pegawai')->with('success','Berhasil Menghapus Pegawai');
    }

    public function all_pegawai(Request $request)
    {
        $search = $request->search;
        if($search == ''){
            $pegawai = Pegawai::orderBy('nama','ASC')->select('id_pegawai','nama')->get();
        }else{
            $pegawai = Pegawai::orderBy('nama','ASC')->select('id_pegawai','nama')->where('nama','like','%'.$search.'%')->get();
        }

        $response = array();
        foreach($pegawai as $data){
            $response[] = array("id" => $data->id_pegawai, "text" => $data->nama);
        }
        return response()->json($response);
    }
}

resources/views/pengguna/akun/create_edit.blade.php
@extends('templates.main')
@section('title', $title)
@section('content')			
    <div class="row justify-content-center">
        <div class="col-md-8">
            <nav aria-label="breadcrumb" class="mb-2">
                <ol class="breadcrumb p-0">
                  <li class="breadcrumb-item">
                    <a href="{{ url("/") }}">
                      <span class="mdi mdi-home"></span>                
                    </a>
                  </li>
                  <li class="breadcrumb-item">
                    <a href="{{ route("jabatan.index") }}">Daftar Akun             
                    </a>
                  </li>
                  <li class="breadcrumb-item text-success" aria-current="page">
                    @if($page == "edit")Edit @else Tambah @endif Akun
                  </li>
                </ol>
            </nav>
            <div class="card card-default">
                <div class="card-header card-header-border-bottom">
                    <h2>@if($page == "edit")Edit @else Tambah @endif Data Akun</h2>
                </div>
                <div class="card-body">
                    <div class="alert alert-warning">
                        <strong>Informasi!</strong> untuk menambahkan akun pegawai silahkan lakukan pada menu tambah pegawai.
                    </div>
                    @if($page == "edit")
                        @php $url = route('akun.update', $akun->userid)  @endphp
                    @else
                        @php $url = url("akun")  @endphp
                    @endif
                    <form action="{{ $url }}" method="post">
                        @csrf
                        @if($page == "edit")
                            {{ method_field('put') }}
                        @endif
                        <div class="form-group">
                            <label>Username <strong class="text-danger">*</strong></label>
                            <input type="text" name="username" class="form-control @error('username') is-invalid @enderror" 
                                placeholder="Username...." @if($page == "edit") value="{{ $akun->username }}" @endif />
                            @error('username')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror 
                        </div>
                        <div class="form-group">
                            <label>Password @if($page != "edit")<strong class="text-danger">*</strong> @endif</label>
                            <input type="password" name="password" class="password_input form-control @error('password') is-invalid @enderror"
                                placeholder="Password...." />
                            @error('password')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror
                            @if($page == "edit")
                                <span class="text-info">Kosongi apabila tidak ingin mengganti password</span>
                            @endif
                        </div>
                        <div class="form-group">
                            <label>Password Pengingat <strong class="text-danger">*</strong></label>
                            <input type="text" name="password_hint" class="form-control @error('password_hint') is-invalid @enderror"
                                placeholder="Password Pengingat...." @if($page == "edit") value="{{ $akun->password_hint }}" @endif/>
                            @error('password_hint')
                                <div class="invalid-feedback">
                                    {{ $message }}  
                                </div>
                            @enderror
                            <span class="text-info">Isikan untuk mengingat password akun.</span>
                        </div>
                        <div class="form-footer pt-4 pt-5 mt-4 border-top">
                            <button type="submit" class="btn btn-primary btn-default">Simpan</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/pengguna/akun/index.blade.php
@extends('templates.main')
@section('title','Halaman Akun')
@section('content')	
    <div class="row justify-content-center">
        <div class="col-md-12">
            <nav aria-label="breadcrumb" class="mb-2">
                <ol class="breadcrumb p-0">
                <li class="breadcrumb-item">
                    <a href="{{ url("/") }}">
                    <span class="mdi mdi-home"></span>                
                    </a>
                </li>
                <li class="breadcrumb-item text-success" aria-current="page">
                    Akun
                </li>
                </ol>
            </nav>
            <div class="card card-default">
                <div class="card-header card-header-border-bottom">
                    <h2>Data Akun</h2>
                </div>
                <div class="card-body">
                    @if(Session::has('success'))
                        <div class="alert alert-dismissible fade show alert-success" role="alert">
                            {{ Session::get("success") }}
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">×</span>
                            </button>
                        </div>
                    @endif
                    <a href="{{ route("akun.create") }}" class="btn btn-success btn-pill mb-3"> <i class="fas fa-plus"></i> Tambah Akun</a>
                    <div class="basic-data-table">
                        <table id="data" class="table nowrap table-bordered" style="width:100%">
                            <thead>
                                <tr>
                                    <td>No</td>
                                    <td>Username</td>
                                    <td>Tipe Akun</td>
                                    <td>Password Hint</td>
                                    <td>Aksi</td>
                                </tr>
                            </thead>
                            <tbody>
                                @php $no = 0; @endphp
                                @foreach ($akun as $item) @php $no++; @endphp
                                    <tr>
                                        <td>{{ $no }}</td>
                                        <td>{{ $item->username }}</td>
                                        <td>{{ $item->tipeakun }}</td>
                                        <td>{{ $item->password_hint }}</td>
                                        <td>
                                            <a href="{{ route("akun.edit",$item->userid) }}" class="btn btn-primary btn-sm">
                                                <i class="fas fa-edit"></i>
                                            </a>
                                            <button type="button" data-toggle="modal" data-target="#exampleModal{{ $item->userid }}" 
                                                class="btn btn-danger btn-sm">
                                                <i class="fas fa-trash"></i>
                                            </button>
                                        </td>
                                    </tr>

                                    <div class="modal fade" id="exampleModal{{ $item->userid }}" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title" id="exampleModalLabel">Hapus Data</h5>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">×</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    Apakah akun {{ $item->username }} akan dihapus ?
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-danger btn-pill" data-dismiss="modal">Tidak</button>
                                                    <form action="{{ route('akun.destroy', $item->userid) }}" method="post"> 
                                                        @csrf
                                                        @method('DELETE')    
                                                        <button type="submit" class="btn btn-primary btn-pill">Ya</button>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection